# -*- coding: utf-8 -*-

import sys
import xbmcaddon
import xbmc
import xbmcgui
import logging
import logging.handlers
import os

ADDON_NAME = 'plugin.video.lrutor'
ADDON = xbmcaddon.Addon(id=ADDON_NAME)
try:
    ADDON_ID = int(sys.argv[1])
    ADDON_URL = sys.argv[0]
    ADDON_PARAMS = dict([i.split('=') for i in sys.argv[2].strip('?').split('&') if i])
    mode = ADDON_PARAMS.get('mode', 'index')
except:
    pass
ADDON_PATH = ADDON.getAddonInfo('path').decode('utf-8')
addon_name = ADDON.getAddonInfo('name').decode('utf-8')
ADDON_PROFILE = xbmc.translatePath(ADDON.getAddonInfo('profile')).decode('utf-8')
if not os.path.exists(ADDON_PROFILE):
    try:
        os.mkdir(ADDON_PROFILE)
    except:
        pass
TURBO_MODE = ADDON.getSetting("turbo_mode") == 'true'
DIRECT_DOWNLOAD_MODE = ADDON.getSetting("direct_download_torrent") == 'true'
EXT_TITLE = ADDON.getSetting("ext_title") == 'true'
SOCKET_TIMEOUT = int(ADDON.getSetting("socket_timeout"))

RUTOR_URL = ADDON.getSetting('url')

USE_PROXY = int(ADDON.getSetting('anti_ban'))
EXCHANGE_TORRENT_INFO = ADDON.getSetting('exchange_torrent_info') == 'true'
SORT_ORDER = int(ADDON.getSetting('sort_order'))


def kodi_notification(text, header=addon_name, time=5000, sound=True):
    dialog = xbmcgui.Dialog()
    dialog.notification(header, text, time=time, sound=sound)
    # xbmc.executebuiltin('Notification(%s,%s)' % (header, text, ))


def setup_logger():
    _logger = logging.getLogger()
    _logger.setLevel(logging.DEBUG)
    _handler = logging.handlers.RotatingFileHandler(os.path.join(ADDON_PATH, 'log', ADDON_NAME + '.log'), maxBytes=1024 * 1024, backupCount=3)
    _handler.setFormatter(logging.Formatter('%(asctime)s %(levelname)s - %(message)s'))
    _logger.addHandler(_handler)
    return _logger


logger = setup_logger()
