# -*- coding: utf-8 -*-

import os
import sys
import xbmc
import xbmcaddon
import xbmcgui
import xbmcplugin
import logging
import urllib


def play_ace(torr_link, ind, fn):
    try:
        from default import ADDON, kodi_notification
        icon = os.path.join(ADDON.getAddonInfo('path'), 'icon.png')
        title = fn
        from TSCore import TSengine as tsengine
        TSplayer = tsengine()
        out = TSplayer.load_torrent(torr_link, 'TORRENT')
        # print out
        if out == 'Ok': TSplayer.play_url_ind(int(ind), title, icon, icon, True)
        TSplayer.end()
        return out
    except Exception, e:
        kodi_notification(str(e))
        return '0'


def play_t2h(uri, file_id, fn, DDir=""):
    try:
        sys.path.append(os.path.join(xbmc.translatePath("special://home/"), "addons", "script.module.torrent2http", "lib"))
        from torrent2http import State, Engine, MediaType
        progressBar = xbmcgui.DialogProgress()
        from contextlib import closing
        if DDir == "": DDir = os.path.join(xbmc.translatePath("special://home/"), "userdata")
        progressBar.create('Torrent2Http', 'Запуск')
        # XBMC addon handle
        # handle = ...
        # Playable list item
        # listitem = ...
        # We can know file_id of needed video file on this step, if no, we'll try to detect one.
        # file_id = None
        # Flag will set to True when engine is ready to resolve URL to XBMC
        ready = False
        # Set pre-buffer size to 15Mb. This is a size of file that need to be downloaded before we resolve URL to XMBC
        pre_buffer_bytes = 15 * 1024 * 1024

        engine = Engine(uri, download_path=DDir, enable_dht=True, dht_routers=["router.bittorrent.com:6881", "router.utorrent.com:6881"], user_agent='uTorrent/2200(24683)')
        with closing(engine):
            # Start engine and instruct torrent2http to begin download first file,
            # so it can start searching and connecting to peers
            engine.start(file_id)
            progressBar.update(0, 'Torrent2Http', 'Загрузка торрента', "")
            while not xbmc.abortRequested and not ready:
                xbmc.sleep(500)
                status = engine.status()
                # Check if there is loading torrent error and raise exception
                engine.check_torrent_error(status)
                # Trying to detect file_id
                if file_id is None:
                    # Get torrent files list, filtered by video file type only
                    files = engine.list(media_types=[MediaType.VIDEO])
                    # If torrent metadata is not loaded yet then continue
                    if files is None:
                        continue
                    # Torrent has no video files
                    if not files:
                        break
                        progressBar.close()
                    # Select first matching file
                    file_id = files[0].index
                    file_status = files[0]
                else:
                    # If we've got file_id already, get file status
                    file_status = engine.file_status(file_id)
                    # If torrent metadata is not loaded yet then continue
                    if not file_status:
                        continue
                if status.state == State.DOWNLOADING:
                    # Wait until minimum pre_buffer_bytes downloaded before we resolve URL to XBMC
                    if file_status.download >= pre_buffer_bytes:
                        ready = True
                        break
                    # print file_status
                    # downloadedSize = status.total_download / 1024 / 1024
                    getDownloadRate = status.download_rate / 1024 * 8
                    # getUploadRate = status.upload_rate / 1024 * 8
                    getSeeds = status.num_seeds

                    progressBar.update(100 * file_status.download / pre_buffer_bytes, 'Предварительная буферизация: ' + str(file_status.download / 1024 / 1024) + " MB",
                                       "Сиды: " + str(getSeeds), "Скорость: " + str(getDownloadRate)[:4] + ' Mbit/s')  #

                elif status.state in [State.FINISHED, State.SEEDING]:
                    # progressBar.update(0, 'T2Http', 'We have already downloaded file', "")
                    # We have already downloaded file
                    ready = True
                    break

                if progressBar.iscanceled():
                    progressBar.update(0)
                    progressBar.close()
                    break
            # Here you can update pre-buffer progress dialog, for example.
            # Note that State.CHECKING also need waiting until fully finished, so it better to use resume_file option
            # for engine to avoid CHECKING state if possible.
            # ...
            progressBar.update(0)
            progressBar.close()
            if ready:
                # Resolve URL to XBMC
                item = xbmcgui.ListItem(path=file_status.url)
                xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                xbmc.sleep(3000)
                xbmc.sleep(3000)
                # Wait until playing finished or abort requested
                while not xbmc.abortRequested and xbmc.Player().isPlaying():
                    xbmc.sleep(500)
    except Exception, e:
        from default import ADDON, kodi_notification
        kodi_notification(str(e))
        logging.error(e, exc_info=True)


def play_yatp(url, ind, fn):
    purl = "plugin://plugin.video.yatp/?action=play&torrent=" + urllib.quote_plus(url) + "&file_index=" + str(ind)
    item = xbmcgui.ListItem(path=purl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)


def play_torrenter(url, ind, fn):
    purl = "plugin://plugin.video.torrenter/?action=playSTRM&url=" + urllib.quote_plus(url) + "&index=" + str(ind)
    item = xbmcgui.ListItem(path=purl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)


def play_elementum(url, ind, fn):
    purl = "plugin://plugin.video.elementum/play?uri=" + urllib.quote_plus(url) + "&index=" + str(ind)
    item = xbmcgui.ListItem(path=purl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)


def play_quasar(url, ind, fn):
    purl = "plugin://plugin.video.quasar/play?uri=" + urllib.quote_plus(url) + "&index=" + str(ind)
    item = xbmcgui.ListItem(path=purl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)


def play_xbmctorrent(url, ind, fn):
    purl = "plugin://plugin.video.xbmctorrent/play/" + urllib.quote_plus(url) + "/" + str(ind)
    item = xbmcgui.ListItem(path=purl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)


PLAY_ENGINES = {
    0: play_ace,
    1: play_t2h,
    2: play_yatp,
    3: play_torrenter,
    4: play_elementum,
    5: play_quasar,
    6: play_xbmctorrent,
}


def play_torrent(engine, url, findex, fn):
    if engine in PLAY_ENGINES:
        PLAY_ENGINES[engine](url, findex, fn)
