# -*- coding: utf-8 -*-

import urllib2
from cookielib import CookieJar
import socket
import re
import time
import json
import logging
import os

TEST_TIMEOUT = 3

socket.setdefaulttimeout(TEST_TIMEOUT)


class HTTPClient:
    def __init__(self, f_proxy=None):
        self.cookies = CookieJar()
        if f_proxy is not None:
            proxy = urllib2.ProxyHandler(f_proxy)
            self.opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(self.cookies), proxy)
        else:
            self.opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(self.cookies))
        self.opener.addheaders = [('User-Agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36')]

    def get_page(self, url):
        return self.opener.open(url, timeout=TEST_TIMEOUT).read()


re_find_table = re.compile(r'<table.*?>(.*?)</table>', re.S + re.I)
re_find_rows = re.compile(r'<tr.*?>(.*?)</tr>', re.S + re.I)
re_find_cols = re.compile(r'<td.*?>(.*?)</td>', re.S + re.I)

TEST_PAGE = {
    'http': 'http://anti-tor.org/',
    'https': 'https://ya.ru',
}

re_find_table = re.compile(r'<table.*?>(.*?)</table>', re.S + re.I)


def test_proxy(proxy_info):
    try:
        start_time = time.time()
        res = HTTPClient(proxy_info['proxy']).get_page(TEST_PAGE['https'] if 'https' in proxy_info['proxy'] else TEST_PAGE['http'])
        if 'http' in proxy_info and len(re_find_table.findall(res)) < 2:
            raise Exception('Слишком мало таблиц, не похоже на rutor')
        proxy_info['time'] = time.time() - start_time
        logging.debug('found proxy %s %f' % (proxy_info['proxy'], proxy_info['time']))
        return proxy_info
    except Exception, e:
        logging.debug('error proxy %s %s' % (proxy_info['proxy'], e))
        return None


def generate(save_path=''):
    html = HTTPClient().get_page('https://free-proxy-list.net/')
    table = re_find_table.findall(html)[0]
    rows = re_find_rows.findall(table)
    test_list = []
    for row in rows:
        cols = re_find_cols.findall(row)
        if len(cols) > 2 and cols[2] != 'RU':
            https = cols[6] == 'yes'
            proto = 'https' if https else 'http'
            test_list.append({'proxy': {proto: '%s:%s' % tuple(cols[:2])}})
            if https:
                test_list.append({'proxy': {'http': '%s:%s' % tuple(cols[:2])}})
    full_proxy_list = []
    s_total = len(test_list)
    s_current = 0.0
    for pi in test_list:
        i = test_proxy(pi)
        s_current += 1
        if i is not None and i['time'] < TEST_TIMEOUT:
            full_proxy_list.append(i)
            yield int(s_current / s_total * 100), str(i['proxy'])
    proxy_list = []
    for http, https in zip(filter(lambda x: 'http' in x['proxy'], full_proxy_list), filter(lambda x: 'https' in x['proxy'], full_proxy_list)):
        proxy_list.append({
            'http': http['proxy']['http'],
            'https': https['proxy']['https'],
            'quality': 5,
        })
    open(os.path.join(save_path, 'proxy_list.json'), 'wb').write(json.dumps(proxy_list))


def main():
    for p, m in generate():
        print p, m
    print 'Done'


if __name__ == '__main__':
    main()
